/***
  GpsConnectorLib.cs
  GPS𓮂Cu
  
  for C#2.0(VisualStudio2005)
  Date: 2006/10/17
  Author: Sho Hashimoto
  WebSite: http://shokai.org
 ***/

using System;
using System.Collections.Generic;
using System.Text;
using System.IO.Ports;

namespace Org.Shokai.Util
{
    class GpsData{
        /// <summary>
        /// ox
        /// </summary>
        public double lat = 0; // ܓx
        /// <summary>
        /// ܓx
        /// </summary>
        public double lon = 0; // ox
        public Boolean E, W, N, S;
        public GpsData()
        {
            E = true; // o
            W = false;
            N = true; // k
            S = false;
        }
    }

    class GpsConnector
    {
        public GpsData gpsData = new GpsData();

        public GpsConnector()
        {
            serialPort = new SerialPort();
            PortName = "COM1";
            BaudRate = 4800;
            serialPort.DataReceived += serialPort_DataReceived;
        }

#region Property and Accessor
        private SerialPort serialPort;

        public String PortName
        {
            set
            {
                this.serialPort.PortName = value;
            }
            get
            {
                return this.serialPort.PortName;
            }
        }

        public int BaudRate
        {
            set
            {
                this.serialPort.BaudRate = value;
            }
            get
            {
                return this.serialPort.BaudRate;
            }
        }

        public Boolean IsOpen
        {
            get
            {
                return this.serialPort.IsOpen;
            }
        }
#endregion

#region Method
        public Boolean connect()
        {
            if (IsOpen) return false; // ɊJĂ
            try
            {
                serialPort.Open();
            }
            catch
            {
            }
            return serialPort.IsOpen;
        }

        public Boolean close()
        {
            if (!IsOpen) return false; // ɕĂ
            try
            {
                serialPort.Close();
            }
            catch
            {
            }
            return serialPort.IsOpen;
        }
#endregion

#region Event
        private void serialPort_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            String recvData = serialPort.ReadLine();

            // parse
            String[] data = recvData.Split(',');
            switch (data[0])
            {
                case "$GPGGA":
                    gpsData.lat = Double.Parse(data[2])/100;
                    if (data[3] == "W")
                    {
                        gpsData.lat *= -1; // o
                    }
                    gpsData.lon = Double.Parse(data[4])/100;
                    if (data[5] == "S")
                    {
                        gpsData.lon *= -1; // 
                    }
                    break;
                case "$GPRMC":
                    break;
                case "$GPGSA":
                    break;
            }
            //Console.WriteLine(recvData);
        }
#endregion

    }
}
